/*
 * BusMessage.h
 *
 *  Created on: Aug 17, 2010
 *      Author: lamikr
 */

#ifndef BUSMESSAGE_H_
#define BUSMESSAGE_H_

#include <string>

namespace plpbus {
	class BusMessage
	{
		public:
			void	*_dataItemSeq;

			BusMessage(long type_param);
			BusMessage(long type_param, const char *arg_name_param, const char *arg_string_value_param);
			virtual ~BusMessage();
			int add_cstring_parameter(const char *arg_name_param, const char *value_param);
			int add_string_parameter(std::string arg_name_param, std::string value_param);
			int add_long_parameter(std::string arg_name_param, long value_param);
			int add_int_parameter(std::string arg_name_param, int value_param);
			int add_double_parameter(std::string arg_name_param, double value_param);
			int add_float_parameter(std::string arg_name_param, float value_param);
			long get_type(int *err_flg);
			std::string get_string_parameter(std::string arg_name_param, int *err_flg);
			long get_long_parameter(std::string arg_name_param, int *err_flg);
			int get_int_parameter(std::string arg_name_param, int *err_flg);
			double get_double_parameter(std::string arg_name_param, int *err_flg);
			float get_float_parameter(std::string arg_name_param, int *err_flg);
			void printout();
		protected:
			BusMessage();
			void printout_dataitem(long index, void *item);
	};
}

#endif /* BUSMESSAGE_H_ */
